Package com.io7m.jregions.core.unparameterized.areas

# Class AreaYSplitD<T extends AreaDType>

java.lang.Object
com.io7m.jregions.core.unparameterized.areas.AreaYSplitD<T>

Type Parameters:
  `T` - The precise type of area

All Implemented Interfaces:
  `AreaYSplitDType<T>`

    public final class AreaYSplitD<T extends AreaDType>
    extends java.lang.Object
    implements AreaYSplitDType<T>

An area that has been split via the Y axis.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `AreaYSplitD.Builder<T extends AreaDType>` | Builds instances of type `AreaYSplitD`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static <T extends AreaDType> AreaYSplitD.Builder<T>` | `builder()` | Creates a builder for `AreaYSplitD`.
  `static <T extends AreaDType> AreaYSplitD<T>` | `copyOf​(AreaYSplitDType<T> instance)` | Creates an immutable copy of a `AreaYSplitDType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `AreaYSplitD` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `lower`, `upper`.
  `T` | `lower()` |
  `static <T extends AreaDType> AreaYSplitD<T>` | `of​(T lower, T upper)` | Construct a new immutable `AreaYSplitD` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `AreaYSplitD` with attribute values.
  `T` | `upper()` |
  `AreaYSplitD<T>` | `withLower​(T value)` | Copy the current immutable object by setting a value for the `lower` attribute.
  `AreaYSplitD<T>` | `withUpper​(T value)` | Copy the current immutable object by setting a value for the `upper` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### lower

    public T lower()
    Specified by:
      `lower` in interface `AreaYSplitDType<T extends AreaDType>`
    Returns:
      The lower half

  - ### upper

    public T upper()
    Specified by:
      `upper` in interface `AreaYSplitDType<T extends AreaDType>`
    Returns:
      The upper half

  - ### withLower

    public final AreaYSplitD<T> withLower​(T value)
    Copy the current immutable object by setting a value for the `lower` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for lower
    Returns:
      A modified copy of the `this` object

  - ### withUpper

    public final AreaYSplitD<T> withUpper​(T value)
    Copy the current immutable object by setting a value for the `upper` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for upper
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `AreaYSplitD` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `lower`, `upper`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `AreaYSplitD` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static <T extends AreaDType> AreaYSplitD<T> of​(T lower, T upper)
    Construct a new immutable `AreaYSplitD` instance.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `lower` - The value for the `lower` attribute
      `upper` - The value for the `upper` attribute
    Returns:
      An immutable AreaYSplitD instance

  - ### copyOf

    public static <T extends AreaDType> AreaYSplitD<T> copyOf​(AreaYSplitDType<T> instance)
    Creates an immutable copy of a `AreaYSplitDType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable AreaYSplitD instance

  - ### builder

    public static <T extends AreaDType> AreaYSplitD.Builder<T> builder()
    Creates a builder for `AreaYSplitD`.

         AreaYSplitD.&lt;T&gt;builder()
            .setLower(T) // required lower
            .setUpper(T) // required upper
            .build();

    Type Parameters:
      `T` - generic parameter T
    Returns:
      A new AreaYSplitD builder